OpenVDB: TypeList< Ts > Struct Template Reference

OpenVDB 9.0.0

Public Types | Static Public Member Functions | Static Public Attributes | List of all members
TypeList< Ts > Struct Template Reference

A list of types (not necessarily unique) More...

`#include <openvdb/TypeList.h>`

## Public Types
using | Self = TypeList
| The type of this list. More...
template<size_t N>
using | Get = typename typelist_internal::TSGetElementImpl< Self, N >::type
| Access a particular element of this type list. If the index is out of range, typelist_internal::NullType is returned. More...
using | Front = Get< 0 >
using | Back = Get< Size-1 >
template<typename ListT = TypeList<>>
using | Unique = typename typelist_internal::TSMakeUniqueImpl< ListT, Ts... >::type
| Remove any duplicate types from this TypeList by rotating the next valid type left (maintains the order of other types). Optionally combine the result with another TypeList. More...
template<typename... TypesToAppend>
using | Append = typename typelist_internal::TSAppendImpl< Self, TypesToAppend... >::type
| Append types, or the members of another TypeList, to this list. More...
template<typename... TypesToRemove>
using | Remove = typename typelist_internal::TSRemoveImpl< Self, TypesToRemove... >::type
| Remove all occurrences of one or more types, or the members of another TypeList, from this list. More...
using | PopFront = typename typelist_internal::TSRemoveFirstImpl< Self >::type
| Remove the first element of this type list. Has no effect if the type list is already empty. More...
using | PopBack = typename typelist_internal::TSRemoveLastImpl< Self >::type
| Remove the last element of this type list. Has no effect if the type list is already empty. More...
template<size_t First, size_t Last>
using | RemoveByIndex = typename typelist_internal::TSRemoveIndicesImpl< Self, First, Last >::type
| Return a new list with types removed by their location within the list. If First is equal to Last, a single element is removed (if it exists). If First is greater than Last, the list remains unmodified. More...

## Static Public Member Functions
template<typename OpT >
static void | foreach (OpT op)
| Invoke a templated, unary functor on a value of each type in this list. More...

## Static Public Attributes
static constexpr size_t | Size = sizeof...(Ts)
| The number of types in the type list. More...
template<typename T >
static constexpr bool | Contains = typelist_internal::TSHasTypeImpl<Self, T>::Value
| True if this list contains the given type, false otherwise. More...
template<typename T >
static constexpr int64_t | Index = typelist_internal::TSHasTypeImpl<Self, T>::Index
| Returns the index of the first found element of the given type, -1 if no matching element exists. More...

## Detailed Description

template<typename... Ts>
struct openvdb::v9_0::TypeList< Ts >

A list of types (not necessarily unique)

Example:

using MyTypes = openvdb::TypeList<int, float, int, double, float>;
openvdb::v9_0::TypeList
A list of types (not necessarily unique)
Definition: TypeList.h:366

## Member Typedef Documentation

## ◆ Append

using Append = typename typelist_internal::TSAppendImpl<Self, TypesToAppend...>::type

Append types, or the members of another TypeList, to this list.

Example:

{
using IntTypes = openvdb::TypeList<Int16, Int32, Int64>;
using RealTypes = openvdb::TypeList<float, double>;
using NumericTypes = IntTypes::Append<RealTypes>;
}
{
using IntTypes = openvdb::TypeList<Int16>::Append<Int32, Int64>;
using NumericTypes = IntTypes::Append<float>::Append<double>;
}
openvdb::v9_0::Int64
int64_t Int64
Definition: Types.h:57
openvdb::v9_0::Int32
int32_t Int32
Definition: Types.h:56

## ◆ Back

using Back = Get<Size-1>

## ◆ Front

using Front = Get<0>

## ◆ Get

using Get = typename typelist_internal::TSGetElementImpl<Self, N>::type

Access a particular element of this type list. If the index is out of range, typelist_internal::NullType is returned.

## ◆ PopBack

using PopBack = typename typelist_internal::TSRemoveLastImpl<Self>::type

Remove the last element of this type list. Has no effect if the type list is already empty.

Example:

{
using IntTypes = openvdb::TypeList<Int16, Int32, Int64>;
using EmptyTypes = openvdb::TypeList<>;
}
{
IntTypes::PopBack; // openvdb::TypeList<Int16, Int32>;
EmptyTypes::PopBack; // openvdb::TypeList<>;
}

## ◆ PopFront

using PopFront = typename typelist_internal::TSRemoveFirstImpl<Self>::type

Remove the first element of this type list. Has no effect if the type list is already empty.

Example:

{
using IntTypes = openvdb::TypeList<Int16, Int32, Int64>;
using EmptyTypes = openvdb::TypeList<>;
}
{
IntTypes::PopFront; // openvdb::TypeList<Int32, Int64>;
EmptyTypes::PopFront; // openvdb::TypeList<>;
}

## ◆ Remove

using Remove = typename typelist_internal::TSRemoveImpl<Self, TypesToRemove...>::type

Remove all occurrences of one or more types, or the members of another TypeList, from this list.

Example:

{
using NumericTypes = openvdb::TypeList<float, double, Int16, Int32, Int64>;
using LongTypes = openvdb::TypeList<Int64, double>;
using ShortTypes = NumericTypes::Remove<LongTypes>; // float, Int16, Int32
}

## ◆ RemoveByIndex

using RemoveByIndex = typename typelist_internal::TSRemoveIndicesImpl<Self, First, Last>::type

Return a new list with types removed by their location within the list. If First is equal to Last, a single element is removed (if it exists). If First is greater than Last, the list remains unmodified.

Example:

{
using NumericTypes = openvdb::TypeList<float, double, Int16, Int32, Int64>;
}
{
using IntTypes = NumericTypes::RemoveByIndex<0,1>; // openvdb::TypeList<Int16, Int32, Int64>;
using RealTypes = NumericTypes::RemoveByIndex<2,4>; // openvdb::TypeList<float, double>;
using RemoveFloat = NumericTypes::RemoveByIndex<0,0>; // openvdb::TypeList<double, Int16, Int32, Int64>;
}

## ◆ Self

using Self = TypeList

The type of this list.

## ◆ Unique

using Unique = typename typelist_internal::TSMakeUniqueImpl<ListT, Ts...>::type

Remove any duplicate types from this TypeList by rotating the next valid type left (maintains the order of other types). Optionally combine the result with another TypeList.

Example:

{
using Types = openvdb::TypeList<Int16, Int32, Int16, float, float, Int64>;
}
{
using UniqueTypes = Types::Unique<>; // <Int16, Int32, float, Int64>
}

## Member Function Documentation

## ◆ foreach()

static void foreach | ( | OpT | op | ) |
| inlinestatic

Invoke a templated, unary functor on a value of each type in this list.

Example:

#include <typeinfo>
template<typename ListT>
void printTypeList()
{
std::string sep;
auto op = [&](auto x) { // C++14
std::cout << sep << typeid(decltype(x)).name(); sep = ", "; };
ListT::foreach(op);
}
using MyTypes = openvdb::TypeList<int, float, double>;
printTypeList<MyTypes>(); // "i, f, d" (exact output is compiler-dependent)
openvdb::v9_0::tools::foreach
void foreach(const IterT &iter, XformOp &op, bool threaded=true, bool shareOp=true)
Definition: ValueTransformer.h:382

Note
  The functor object is passed by value. Wrap it with `std::ref` to use the same object for each type.

## Member Data Documentation

## ◆ Contains

constexpr bool Contains = typelist_internal::TSHasTypeImpl<Self, T>::Value
| staticconstexpr

True if this list contains the given type, false otherwise.

Example:

{
using IntTypes = openvdb::TypeList<Int16, Int32, Int64>;
using RealTypes = openvdb::TypeList<float, double>;
}
{
openvdb::TypeList<IntTypes>::Contains<Int32>; // true
openvdb::TypeList<RealTypes>::Contains<Int32>; // false
}

## ◆ Index

constexpr int64_t Index = typelist_internal::TSHasTypeImpl<Self, T>::Index
| staticconstexpr

Returns the index of the first found element of the given type, -1 if no matching element exists.

Example:

{
using IntTypes = openvdb::TypeList<Int16, Int32, Int64>;
using RealTypes = openvdb::TypeList<float, double>;
}
{
const int64_t L1 = openvdb::TypeList<IntTypes>::Index<Int32>; // 1
const int64_t L2 = openvdb::TypeList<RealTypes>::Index<Int32>; // -1
}

## ◆ Size

constexpr size_t Size = sizeof...(Ts)
| staticconstexpr

The number of types in the type list.